#ifndef _TIMING_H
#define _TIMING_H


enum TimeOfDay { Night, Dawn, Morning, Afternoon, Dusk };

class Timing
{
public:

   ~Timing();
   Timing();
   int     init_times();
   long    cycle_elapsed();
   void    set_cycle();
   int     handle_events();
   time_t  plr_TimeSinceHealed();
   time_t  mob_TimeSinceHealed();
   time_t  plr_TimeSinceEndur();
   time_t  plr_TimeSinceMagic();
   time_t  plr_TimeSinceLevel();
   void    set_tod_time(TimeOfDay the_time);

private:

#if defined( AIME_WIN32 )
   FILETIME initial_time;
   FILETIME last_loop;
#else
   timeval initial_time;
   timeval last_loop;
#endif

   long last_second;
   long last_hour;
   long start_day;

   time_t last_heal_players;
   time_t last_heal_mobiles;
   time_t last_magic_players;
   time_t last_endur_players;
   time_t last_level;
};

#endif






